// driver.cpp
//
// PDF Writer driver for BeOS

#include <stdio.h>
#include <string.h>

#include <StorageKit.h>

#include "driver.h"
#include "PDFWriter.h"

static PrinterDriver * 	instanciate_driver(BNode * spool_dir);


BMessage * take_job(BFile * spool_file, BNode * spool_dir, BMessage * msg)
{
	PrinterDriver * driver;
	
	driver = instanciate_driver(spool_dir);
	if ( driver->PrintJob(spool_file, spool_dir, msg) == B_OK )
		msg = new BMessage('okok');
	else	
		msg = new BMessage('baad');
	
	delete driver;
			
	return msg;
}



BMessage * config_page(BNode * spool_dir, BMessage * msg)
{
	BMessage *			pagesetup_msg;
	PrinterDriver * 	driver;

	pagesetup_msg = new BMessage(*msg);

	driver = instanciate_driver(spool_dir);
	if ( driver->PageSetup(pagesetup_msg) == B_OK )
		pagesetup_msg->what = ('okok');
	else
		{
		delete pagesetup_msg;
		pagesetup_msg = NULL;
		};
		
	delete driver;
	
	return pagesetup_msg;
}



BMessage * config_job(BNode * spool_dir, BMessage * msg)
{
	BMessage *			jobsetup_msg;
	PrinterDriver * 	driver;

	jobsetup_msg = new BMessage(*msg);

	driver = instanciate_driver(spool_dir);
	if ( driver->JobSetup(jobsetup_msg) == B_OK )
		jobsetup_msg->what = ('okok');
	else
		{
		delete jobsetup_msg;
		jobsetup_msg = NULL;
		};

	delete driver;
	
	return jobsetup_msg;
}



char * add_printer(char * printer_name)
{
	return printer_name; 
}


static PrinterDriver * instanciate_driver
	(
	BNode *	spool_dir
	)
{
	return new PDFWriter();
}

